#!/usr/local/bin/perl
# -*- coding: utf-8 -*-

use strict;
use Env qw(ESTWORD);
use open IN => ":utf8";

my @a = (
    [ "蛸", "鮹", "鱆", "章魚" ],
    [ "醗酵", "発酵", ],
    [ "百鬼園", "百閒", ],
    [ "函数", "関数", ],
    [ "涩", "渋", "澀", "澁", ],
    [ "間", "间", "閒", ],
    [ "斋", "斎", "齋", ],
    [ "关", "關", "闗", "関", ],
    [ "凾", "函", ],
    [ "数", "數", "數", ],
    [ "发", "発", "發", ],
    [ "酦", "醗", "醱", ],
    [ "畑", "畠", "𤳉", ],
    );


my @e = ( $ESTWORD );

foreach my $j (0 .. $#a) {
    foreach my $i (0 .. $#{$a[$j]}) {
	my $d = 0;
	foreach my $k (@e) {
	    if ($k =~ /$a[$j][$i]/) {
		my @c = expand_est($k, $i, @{$a[$j]});
		push(@e, @c);
		$d = 1;
	    }
	}
	last if $d;
    }
}

printcand(@e);

sub expand_est {
    my ($e, $i, @a) = @_;
    my @b;
    foreach my $j (0 .. $#a) {
	my $t = $e;
	if($j != $i) {
	    $t =~ s/$a[$i]/$a[$j]/;
	    push(@b, $t); 
	}
    }
    return @b;
}

sub printcand {
    my (@c) = @_;
    @c = sort { $a cmp $b } @c;
    print ($c[0] . "\n");
    foreach my $i (1..$#c) {
	if($c[$i] !~ /$c[$i-1]/) {
	    print $c[$i] . "\n";
	}
    }
}

