#!/usr/local/bin/perl

use strict;
binmode STDOUT, ":utf8";

while(<>) {
    if( !/^$/ &&
	!/^\s+$/ &&
	!/^#.*$/ &&
	!/Semantic/) {
	s/\sk[STZ].*ariant\s+/ /;
	s/(U\+[A-F0-9]+) \g1/$1/g;
	s/^U\+[A-F0-9]+\s*$//;
	#	s/(U\+[A-F0-9]+)([^A-F0-9])/conv_glyph($1).$2/eg;
	s/U\+(....[^A-Z0-9])/U+0$1/g;
	print STDOUT;
    }
}

sub conv_glyph {
    /U\+(.+)$/;
    return (pack("U*",hex($1)));    
}	


