#!/usr/local/bin/perl

use strict;

my @v;
my $n = 0;
my $q = 0;
while(<>) {
    if( !/^$/ && !/^#/ ) {
	my @c = parse_ittext($_);
	$q = 0;
	if($n > 0) {
	    foreach my $i (0 .. $n-1) {
		my $e = 0;
		my @m;
		if($q == 0) {
		    foreach my $j (0 .. $#c) {
			$m[$j] = grep(($_ == $c[$j]), @{$v[$i]});
			$e |= ($m[$j] > 0) ? 1 : 0;
		    }
		    if($e) {
			$q++;
			foreach my $k (0 .. $#c) {
			    if ($m[$k] == 0) {
				push($v[$i], $c[$k]);
			    }
			}
		    }
		}
	    }
	}
	if($q == 0) {
	    $v[$n++] = [ @c ];
	}
    }
}

printhecd ($n, @v);

sub printhecd {
    my ($n, @t) = @_;
    foreach my $i (0 .. $n-1) {
	my @x;
	foreach my $k (@{$t[$i]}) {
	    push(@x, $k);
	}
	@x = sort{$a <=> $b} @x;
	printhequ(@x);
    }
}

sub printhequ {
    my (@x) = @_;
    binmode STDOUT, ":utf8";
    print "    [";
    foreach my $j (@x) {
	print ' "' . (pack("U*",$j)) . '",';
    }
    print " ],\n";
}
    
sub parse_ittext {
    my (@c);
    s/U\+([A-F0-9]+)[^A-F0-9]/push(@c,$1)/eg;
    foreach my $j (@c) {
	$j = hex($j);
    }
    return (@c);
}	

